import { CommandHandler } from '@nestjs/cqrs';
import { ConfigurationRepository } from '../../adapters/secondaries/configuration.repository';
import { DeleteConfigurationCommand } from '../../commands/delete-configuration.command';
import { Configuration } from '../entities/configuration';

@CommandHandler(DeleteConfigurationCommand)
export class DeleteConfigurationUseCase {
  constructor(private readonly _repository: ConfigurationRepository) {}

  async execute(command: DeleteConfigurationCommand): Promise<Configuration> {
    try {
      const configuration = await this._repository.delete(command.uuid);
      return configuration;
    } catch (error) {
      throw error;
    }
  }
}
